unit EuroCarMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Objects,
  FMX.RS.SVGCodec, FMX.ImgList, System.ImageList, FMX.RS.SVGImgList, FMX.Layouts,
  FMX.RS.SVGTypes, FMX.RS.SVG, FMX.RS.SVGCtrls, FMX.Effects, FMX.Filter.Effects,
  Generics.Collections;

type
  TCountry = record
    Name: String;
    Expenses: Integer;
    Income: Single;
    EU: Boolean;
    constructor Create( aName: String; aExpenses: Integer;
      aIncome: Single; aEU: Boolean = True);
  end;
  TCountries = class(TDictionary<String,TCountry>);
  TForm1 = class(TForm)
    Image1: TImage;
    RSSVGImageList1: TRSSVGImageList;
    Glyph1: TGlyph;
    Layout1: TLayout;
    Text1: TText;
    Layout2: TLayout;
    Glyph2: TGlyph;
    RSFmxSVGDocument1: TRSFmxSVGDocument;
    RSSVGImage1: TRSSVGImage;
    RSSVGImage2: TRSSVGImage;
    ShadowEffect1: TShadowEffect;
    ContrastEffect1: TContrastEffect;
    RSFmxSVGDocument2: TRSFmxSVGDocument;
    RSSVGImage3: TRSSVGImage;
    ContrastEffect2: TContrastEffect;
    RSSVGPanel1: TRSSVGPanel;
    RSFmxSVGDocument3: TRSFmxSVGDocument;
    RSSVGLayout1: TRSSVGLayout;
    RSSVGLayout2: TRSSVGLayout;
    RSSVGLayout3: TRSSVGLayout;
    RSSVGLayout4: TRSSVGLayout;
    RSSVGLayout5: TRSSVGLayout;
    RSSVGPath1: TRSSVGPath;
    RSSVGLayout6: TRSSVGLayout;
    RSSVGPath2: TRSSVGPath;
    RSSVGLayout7: TRSSVGLayout;
    RSSVGPath3: TRSSVGPath;
    RSSVGLayout8: TRSSVGLayout;
    RSSVGPath4: TRSSVGPath;
    RSSVGLayout9: TRSSVGLayout;
    RSSVGPath5: TRSSVGPath;
    RSSVGLayout10: TRSSVGLayout;
    RSSVGPath6: TRSSVGPath;
    RSSVGLayout11: TRSSVGLayout;
    RSSVGPath7: TRSSVGPath;
    RSSVGLayout12: TRSSVGLayout;
    RSSVGPath8: TRSSVGPath;
    RSSVGLayout13: TRSSVGLayout;
    RSSVGPath9: TRSSVGPath;
    RSSVGLayout14: TRSSVGLayout;
    RSSVGPath10: TRSSVGPath;
    RSSVGLayout15: TRSSVGLayout;
    RSSVGPath11: TRSSVGPath;
    RSSVGLayout16: TRSSVGLayout;
    RSSVGPath12: TRSSVGPath;
    RSSVGLayout17: TRSSVGLayout;
    RSSVGPath13: TRSSVGPath;
    RSSVGLayout18: TRSSVGLayout;
    RSSVGPath14: TRSSVGPath;
    RSSVGLayout19: TRSSVGLayout;
    RSSVGPath15: TRSSVGPath;
    RSSVGLayout20: TRSSVGLayout;
    RSSVGPath16: TRSSVGPath;
    RSSVGLayout21: TRSSVGLayout;
    RSSVGPath17: TRSSVGPath;
    RSSVGLayout22: TRSSVGLayout;
    RSSVGPath18: TRSSVGPath;
    Text2: TText;
    PaintBox1: TPaintBox;
    SwitchOn: TRSFmxSVGDocument;
    SwitchOff: TRSFmxSVGDocument;
    procedure RSFmxSVGDocument1Loaded(Sender: TObject);
    procedure RSSVGImage1ClickElement(Sender: TObject;
      const Element: TSVGGraphicElement);
    procedure RSSVGImage1Paint(Sender: TObject; Canvas: TCanvas;
      const ARect: TRectF);
    procedure RSSVGImage3ClickElement(Sender: TObject;
      const Element: TSVGGraphicElement);
    procedure RSSVGImage3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure RSSVGImage3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
    procedure PaintBox1Click(Sender: TObject);
  private
    { Private declarations }
    FSelected: TSVGGraphicElement;
    FCountries: TCountries;
    procedure SetSelected(const Value: TSVGGraphicElement);
    function GetCountries: TCountries;
  public
    { Public declarations }
    property Countries: TCountries read GetCountries;
    property Selected: TSVGGraphicElement read FSelected write SetSelected;
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

uses
  StrUtils;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FCountries.Free;
end;

function TForm1.GetCountries: TCountries;
begin
  if FCountries = nil then
  begin
    FCountries := TCountries.Create;
    FCountries.Add('la-fr',TCountry.Create('France', 10, 10));
    FCountries.Add('la-it',TCountry.Create('Italy', 10, 10));
    FCountries.Add('la-uk',TCountry.Create('United Kingdom', 10, 10));
    FCountries.Add('la-ic',TCountry.Create('Iceland', 10, 10));
    FCountries.Add('la-es',TCountry.Create('Spain', 10, 10));
    FCountries.Add('la-ie',TCountry.Create('Ireland', 10, 10));
    FCountries.Add('la-pt',TCountry.Create('Portugal', 10, 10));
    FCountries.Add('la-gr',TCountry.Create('Greece', 10, 10));
    FCountries.Add('la-de',TCountry.Create('Germany', 10, 10));
    FCountries.Add('la-no',TCountry.Create('Norway', 10, 10));
    FCountries.Add('la-se',TCountry.Create('Sweden', 10, 10));
    FCountries.Add('la-fi',TCountry.Create('Finland', 10, 10));
    FCountries.Add('la-nl',TCountry.Create('Netherlands', 10, 10));
    FCountries.Add('la-be',TCountry.Create('Belgium', 10, 10));
    FCountries.Add('la-at',TCountry.Create('Austria', 10, 10));
    FCountries.Add('la-bg',TCountry.Create('Bulgaria', 10, 10));
    FCountries.Add('la-hr',TCountry.Create('Croatia', 10, 10));
    FCountries.Add('la-cy',TCountry.Create('Cyprus', 10, 10));
    FCountries.Add('la-cz',TCountry.Create('Czech Republic', 10, 10));
    FCountries.Add('la-dk',TCountry.Create('Denmark', 10, 10));
    FCountries.Add('la-ee',TCountry.Create('Estonia', 10, 10));
    FCountries.Add('la-lv',TCountry.Create('Latvia', 10, 10));
    FCountries.Add('la-lt',TCountry.Create('Lithuania', 10, 10));
    FCountries.Add('la-lu',TCountry.Create('Luxembourg', 10, 10));
    FCountries.Add('la-mt',TCountry.Create('Malta', 10, 10));
    FCountries.Add('la-pl',TCountry.Create('Poland', 10, 10));
    FCountries.Add('la-ro',TCountry.Create('Romania', 10, 10));
    FCountries.Add('la-sk',TCountry.Create('Slovakia', 10, 10));
    FCountries.Add('la-si',TCountry.Create('Slovenia', 10, 10));
    FCountries.Add('la-by',TCountry.Create('Belarus', 10, 10, False));
    FCountries.Add('la-tr',TCountry.Create('Turkey', 10, 10, False));
    FCountries.Add('la-iq',TCountry.Create('Iraq', 10, 10, False));
    FCountries.Add('la-jo',TCountry.Create('Jordan', 10, 10, False));
    FCountries.Add('la-ru',TCountry.Create('Russia', 10, 10, False));
    FCountries.Add('la-lb',TCountry.Create('Libya', 10, 10, False));
    FCountries.Add('la-ma',TCountry.Create('Morocco', 10, 10, False));
    FCountries.Add('la-dz',TCountry.Create('Algeria', 10, 10, False));
    FCountries.Add('la-tn',TCountry.Create('Tunisia', 10, 10, False));
    FCountries.Add('la-il',TCountry.Create('Isreal', 10, 10, False));
    FCountries.Add('la-im',TCountry.Create('Isle of Man', 10, 10, False));
    FCountries.Add('la-kz',TCountry.Create('Kazakhstan', 10, 10, False));
    FCountries.Add('la-ir',TCountry.Create('Iran', 10, 10, False));
    FCountries.Add('la-sa',TCountry.Create('Saudi Arabia', 10, 10, False));
    FCountries.Add('la-ga',TCountry.Create('Gabon', 10, 10, False));
    FCountries.Add('la-ge',TCountry.Create('Georgia', 10, 10, False));
    FCountries.Add('la-sy',TCountry.Create('Syria', 10, 10, False));
    FCountries.Add('la-md',TCountry.Create('Moldova', 10, 10, False));
    FCountries.Add('la-ua',TCountry.Create('Ukraine', 10, 10, False));
    FCountries.Add('la-az',TCountry.Create('Azerbaijan', 10, 10, False));
    FCountries.Add('la-am',TCountry.Create('Armenia', 10, 10, False));
    FCountries.Add('la-bh',TCountry.Create('Bahrain', 10, 10, False));
  end;
  result := FCountries;
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
begin
  (Sender as TPaintBox).Tag := (TPaintBox(Sender).Tag + 1) mod 2;
  TPaintBox(Sender).Repaint;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject; Canvas: TCanvas);
begin
  if (Sender as TPaintBox).Tag = 0 then
    SwitchOff.SVG.Draw(Canvas, TPaintBox(Sender).ClipRect)
  else
    SwitchOn.SVG.Draw(Canvas, TPaintBox(Sender).ClipRect);
end;

procedure TForm1.RSFmxSVGDocument1Loaded(Sender: TObject);
var
  Element: TSVGElement;
  aCountry: TCountry;
begin
  for Element in RSFmxSVGDocument1.SVG.AllItems.Values do
  begin
    if (Element is TSVGGraphicElement) and (TSVGGraphicElement(Element).Brush.Opacity < 1) then
    begin
      TSVGGraphicElement(Element).Inherits.FillOpacity := True;
      if (Countries.TryGetValue(Element.Parent.ID, aCountry) and
        (not aCountry.EU)) then
        TSVGGraphicElement(Element).Brush.Color := TAlphaColorRec.Gray;
    end;
  end;
end;

procedure TForm1.RSSVGImage1ClickElement(Sender: TObject;
  const Element: TSVGGraphicElement);
begin
  if (Element = nil) or
    ((Element.Parent <> nil) and StartsText('la-',Element.Parent.ID)) then
    Selected := Element
  else
    Selected := nil;
end;

procedure TForm1.RSSVGImage1Paint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
var
  SelectRect: TRectF;
  Matrix: TSVGMatrix;
begin
  if Selected <> nil then
  begin
    SelectRect := aRect;
    // the entire map selection rectangle based on wrap mode
    SelectRect := GetWrapModeRect( (Sender as TRSSVGImage).SVGDocument.SVG,
      SelectRect, (Sender as TRSSVGImage).WrapMode, TRSSVGImage(Sender).ScaleOriginal);
    // use the rectangle to figure out what transformation matrix was applied
    // to draw the svg image
    if (TRSSVGImage(Sender).SVGRootID = '') then
      Matrix := TRSSVGImage(Sender).SVGDocument.SVG.GetViewMatrix(
        TRSSVGImage(Sender).SVGDocument.SVG.FitToRect(SelectRect), SelectRect)
    else
      Matrix := TRSSVGImage(Sender).SVGRoot.FitToRect(SelectRect);
    // now we have matrix for drawing entire SVG
    // get the matrix for drawing selected element
    Matrix := Selected.GetTransformationMatrix(Matrix);
    // now get the bounds rect of the element
    SelectRect := Selected.GetBoundsRect(Matrix);
    // now draw the focus rectangle
    Canvas.Stroke.Color := TAlphaColorRec.Gray;
    Canvas.DrawRect(SelectRect, 0, 0, AllCorners, 0.5);
  end;
end;

procedure TForm1.RSSVGImage3ClickElement(Sender: TObject;
  const Element: TSVGGraphicElement);
begin
  if Element <> nil then
    Selected := nil;
end;

procedure TForm1.RSSVGImage3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  if ((Sender as TRSSVGImage).SVGDocument.SVG.ElementAtPos(
    (Sender as TRSSVGImage).SVGRoot.FitToRect((Sender as TRSSVGImage).ClipRect),
    (Sender as TRSSVGImage).Canvas, PointF(X,Y), (Sender as TRSSVGImage).ClipRect ) <> nil) then
    ContrastEffect2.Enabled := True;

end;

procedure TForm1.RSSVGImage3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
  ContrastEffect2.Enabled := False;
end;

procedure TForm1.SetSelected(const Value: TSVGGraphicElement);
var
  aCountry: TCountry;
begin
  if Value <> Selected then
  begin
    FSelected := Value;
    if Selected = nil then
    begin
      RSSVGImage2.SVGDocument := nil;
      Text2.Text := '';
    end
    else
    begin
      RSSVGImage2.SVGDocument := RSFmxSVGDocument1;
      RSSVGImage2.SVGRootID := Selected.ID;
      if (Selected.Parent <> nil) and (Countries.TryGetValue(Selected.Parent.ID, aCountry)) then
        Text2.Text := aCountry.Name
      else
        Text2.Text := '';
    end;
    RSSVGImage1.Repaint;
    RSSVGImage2.UpdateEffects;
    ContrastEffect1.Enabled := Selected <> nil;
    RSSVGImage1.UpdateEffects;
  end;
end;

{ TCountry }

constructor TCountry.Create(aName: String; aExpenses: Integer;
  aIncome: Single; aEU: Boolean);
begin
  Name := aName;
  Expenses := aExpenses;
  Income := aIncome;
  EU := aEU;
end;

end.
